<script setup lang="ts">
import { ChevronLgRight, Access } from 'slippers-ui/icons';
import type { BaseLink, BaseImage } from '@/types/base';

defineProps({
  title: {
    type: String,
    required: false,
  },
  description: {
    type: String,
    required: false,
  },
  button: {
    type: Object as PropType<BaseLink>,
    required: true,
  },
  image: {
    type: Object as PropType<BaseImage>,
    required: false,
  },
  icon: {
    type: String,
    required: false,
  },
});
</script>

<template>
  <section class="wrapper">
    <SlpContainer>
      <SlpRow class="side-card-image">
        <SlpColumn cols="6" class="slp-py-48 side-card-image__content">
          <SlpIcon :icon="Access" size="lg" />
          <SlpTypography variant="heading4-bold" tag="h2" class="slp-my-16">
            {{ title }}
          </SlpTypography>
          <SlpTypography variant="heading5" tag="p">
            {{ description }}
          </SlpTypography>
          <SlpButton
            :href="button.config.href"
            variant="tertiary"
            class="slp-mt-24"
            :data-ga-name="button.config.dataGaName"
            :data-ga-location="button.config.dataGaLocation"
            >{{ button.text }}
            <SlpIcon :icon="ChevronLgRight" size="sm" class="slp-ml-8" />
          </SlpButton>
        </SlpColumn>
        <SlpColumn cols="6" class="side-card-image__image-container">
          <img v-if="image" :src="image.config.src" :alt="image.altText" class="side-card-image__image" />
        </SlpColumn>
      </SlpRow>
    </SlpContainer>
  </section>
</template>

<style lang="scss" scoped>
.wrapper {
  margin: $spacing-64 0;
  @media (max-width: $breakpoint-md) {
    margin: $spacing-32 0;
  }
}

.side-card-image {
  background-color: $color-surface-800;
  border-radius: 0 4px 100px 0;

  &__content {
    background-color: $color-surface-800;
    position: relative;

    &::before {
      content: '';
      position: absolute;
      top: 0;
      left: -400px;
      width: 400px;
      height: 100%;
      background-color: $color-surface-800;
    }
  }

  &__image {
    border-radius: 0 4px 100px 0;
    float: right;
    height: 100%;
    max-width: 100%;
  }

  @media (max-width: $breakpoint-md) {
    &::before {
      display: none;
    }

    &__content {
      padding-left: 24px;
      &::before {
        display: none;
      }
    }

    &__image-container {
      width: 100%;

      img {
        width: 100%;
      }
    }
  }
}
</style>
